package com.javaworld.JavaBeans.Oct99;

import com.javaworld.JavaBeans.Oct99.ColorFadeBar;
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.beans.*;

// This is the JavaBean wrapper for an existing applet
public class ColorFadeBean
	extends ColorFadeBar
	implements Serializable	// Every JavaBean must be Serializable
{
	protected PropertyChangeSupport pcs_ = new PropertyChangeSupport(this);

	public ColorFadeBean()
	{
		super();
	}
	//
	// Property change listeners
	//
	public void addPropertyChangeListener(PropertyChangeListener l)
	{
		System.out.println("Added property change listener");
		pcs_.addPropertyChangeListener(l);
	}
	public Color getColorFrom() { return _colorFrom;}
	public Color getColorTo() { return _colorTo;}
	public int getFadeDirection() { return _iFadeDirection;}
	public int getHeight() { return _iVpoints; }
	public String getMessage() { return _sString; }
	public Color getMessageColor() { return _colorText;}
	public Font getMessageFont() {
		if (_messageFont == null) {
			return new Font("Sans-Serif", Font.BOLD, 16);
		}
		return _messageFont;
	}
	public int getTextDirection() { return _iTextDirection;}
	public int getWidth() { return _iHpoints;}
	//
	// Listen for property changes
	//

	//
	// A property change occurred in something I'm listening to
	//
	public void propertyChange(PropertyChangeEvent evt)
	{
		String	sPropertyName = evt.getPropertyName();
		Object  objNewValue   = evt.getNewValue();
		Object  objOldValue   = evt.getOldValue();

		System.out.println("Got a property change event for " + sPropertyName);

		if (sPropertyName == "FadeDirection") {
			setFadeDirection(((Integer)objNewValue).intValue());
		} else if (sPropertyName == "TextDirection") {
			setTextDirection(((Integer)objNewValue).intValue());
		}
	}
	public void removePropertyChangeListener(PropertyChangeListener l)
	{
		pcs_.removePropertyChangeListener(l);
	}
	// Handle real-time resizes.
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x,y,width,height);
		setWidth(width);
		setHeight(height);
	}
	// Color From property
	public void setColorFrom(Color newColor) { _colorFrom = newColor;}
	// ColorTo property
	public void setColorTo(Color newColor) { _colorTo = newColor;}
	// Fade direction
	public void setFadeDirection(int iNewFadeDirection)
	{
		// If new direction is out of range, ignore
		if (iNewFadeDirection >= 0 || iNewFadeDirection <= 4) {
			pcs_.firePropertyChange("FadeDirection",
									new Integer(_iFadeDirection),
									new Integer(iNewFadeDirection));

			_iFadeDirection = iNewFadeDirection;
			repaint();
		}
	}
	// Height property
	public void setHeight(int iHeight) { _iVpoints = iHeight; }
	// Message property
	public void setMessage(String sText) {        _sString = sText;    }
	// Message color
	public void setMessageColor(Color color) { _colorText = color;}
	// Message font property
	public void setMessageFont(Font font) {
		if (font == null) { font = new Font("Helvetica", Font.BOLD, 16); }
		_messageFont = font;
	}
	// Text direction
	public void setTextDirection(int iNewTextDirection)
	{
		// If new direction is out of range, throw
		// exception
		if (iNewTextDirection == LEFT || iNewTextDirection == RIGHT ||
			iNewTextDirection == CENTER) {

			pcs_.firePropertyChange("TextDirection",
									new Integer(_iTextDirection),
									new Integer(iNewTextDirection));

			_iTextDirection = iNewTextDirection;
			repaint();
		}
	}
	//
	// PROPERTY ACCESSORS
	//

	// Width property
	public void setWidth(int iWidth) { _iHpoints = iWidth;}
}