package com.javaworld.JavaBeans.Oct99;

import com.ibm.bml.*;
import java.awt.*;

// Defines and registers an object that converts
// an Object to a Color. That's pretty easy -- we just return
// the object. By rights, we should throw an exception if
// one of the input classes isn't a color, or the other
// isn't type-convertible, but I'm lazy. Someone will throw
// an exception eventually.

public class ObjectColorConvertor implements BMLSelfRegisterable {

	private class MyTypeConvertor implements com.ibm.bml.TypeConvertor {

		public Object convert(Class from, Class to, Object obj) {

			if (false) {
				// Convert from Object to Color
				if (from == java.lang.Object.class &&
					to == java.awt.Color.class) {
					return obj;
				}
				
				// Convert from Color to Object
				if (from == java.awt.Color.class &&
					to == java.lang.Object.class) {
					return obj;
				}
				
				// Something's very wrong here... this object
				// shouldn't be registered for this conversion.
				// I'm going to return null and let someone else
				// throw the exception (since I have no checked exceptions)
				return null;
			}
			System.out.println("Converted.");
			return obj;
		}
		
		public String getCodeGenString() {
			return "(Class from, Class to, Object obj) {\n" +
				"return obj;\n}\n";
		}
	}
	
	public void register (BMLEnvironment env) {
		
		TypeConvertor tc = new MyTypeConvertor();
		
		// Register Colors and Objects as mutually interconvertible.
		env.typeConvertorRegistry.register(java.lang.Object.class,
										   java.awt.Color.class,
										   tc);
		
		env.typeConvertorRegistry.register(java.awt.Color.class,
										   java.lang.Object.class,
										   tc);
		
		System.out.println("Registered!");
	}
}