<?xml version="1.0"?>
<xsl:stylesheet
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns="http://www-sop.inria.fr/lemme/bo/1.0"
 version="1.0">

<xsl:template match="books">
  <bean class="fr.inria.ketuk.widgets.VBox">
    <add>
      <bean class="fr.inria.ketuk.widgets.VBox">
        <xsl:apply-templates select="select"/>
        <listener name="container"/>
      </bean>
    </add>
  </bean>
</xsl:template>

<xsl:template match="select">
  <add>
  <bean class="fr.inria.ketuk.demos.books.BookIndex">
    <property name="nbBooks"><cast class="int"><string><xsl:value-of select="count(/books/book)"/></string></cast></property>
    <property name="index"><cast class="int"><string><xsl:value-of select="index/@n"/></string></cast></property>
    <listener name="propertyChange"/>
  </bean>
  </add>
  <xsl:variable name="n"><xsl:value-of select="index/@n"/></xsl:variable>
  <add>
    <xsl:apply-templates select="/books/book[position()=$n]"/>
  </add>
</xsl:template>

<xsl:template match="book">
  <bean class="fr.inria.ketuk.demos.books.Book">
      <property name="author"><string><xsl:value-of select="author"/></string></property>
      <property name="title"><string><xsl:value-of select="title"/></string></property>
      <property name="isbn"><string><xsl:value-of select="isbn"/></string></property>
      <property name="nbPages"><string><xsl:value-of select="npages"/></string></property>
      <property name="image"><string><xsl:value-of select="cover/@src"/></string></property>
      <property name="synopsis"><string><xsl:value-of select="description"/></string></property>
      <property name="price"><string><xsl:value-of select="price"/></string></property>
      <property name="rating"><cast class="int"><string><xsl:value-of select="review"/></string></cast></property>
      <listener name="propertyChange"/>
  </bean>
</xsl:template>

</xsl:stylesheet>
