<?xml version="1.0"?>
<xsl:stylesheet
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns="http://www-sop.inria.fr/lemme/bo/1.0"
 version="1.0">

<xsl:template match="books">
  <bean class="fr.inria.ketuk.widgets.VBox">
    <add>
    <bean class="fr.inria.ketuk.widgets.HBox">
      <add>
      <bean class="javax.swing.JTextField">
        <args><cast class="int"><string>50</string></cast></args>
        <property name="text" value="TITLE AND AUTHOR"/>
        <call-method name="setEditable"><string value="false"/></call-method>
        <call-method name="setForeground">
          <field target="class:java.awt.Color" name="red"/>
        </call-method>
      </bean>
      </add>
      <add>
      <bean class="javax.swing.JTextField">
        <args><cast class="int"><string>8</string></cast></args>
        <property name="text" value="RATING"/>
        <call-method name="setEditable"><string value="false"/></call-method>
        <call-method name="setForeground">
          <field target="class:java.awt.Color" name="red"/>
        </call-method>
      </bean>
      </add>
    </bean>
    </add>
    <xsl:apply-templates select="book"/>
  </bean>
</xsl:template>

<xsl:template match="book">
  <add>
  <bean class="fr.inria.ketuk.widgets.HBox">
    <xsl:apply-templates select="*"/>
  </bean>
  </add>
</xsl:template>

<xsl:template match="title">
  <add>
  <bean class="javax.swing.JTextField">
    <args><cast class="int"><string>50</string></cast></args>
    <property name="text" value="{.}, {../author}"/>
    <call-method name="setEditable"><string value="false"/></call-method>
  </bean>
  </add>
</xsl:template>

<xsl:template match="review">
  <add>
  <bean class="javax.swing.JComboBox">
   <call-method name="getRenderer" id="id1"/>
   <call-method name="setPreferredSize" target="id1">
     <bean class="java.awt.Dimension">
       <args>
         <cast class="int"><string>64</string></cast>
         <cast class="int"><string>12</string></cast>
       </args>
     </bean>
   </call-method>
    <call-method name="addItem">
      <bean class="javax.swing.ImageIcon">
        <args><string>images/rating-0.gif</string></args>
      </bean>
    </call-method>
    <call-method name="addItem">
      <bean class="javax.swing.ImageIcon">
        <args><string>images/rating-1.gif</string></args>
      </bean>
    </call-method>
    <call-method name="addItem">
      <bean class="javax.swing.ImageIcon">
        <args><string>images/rating-2.gif</string></args>
      </bean>
    </call-method>
    <call-method name="addItem">
      <bean class="javax.swing.ImageIcon">
        <args><string>images/rating-3.gif</string></args>
      </bean>
    </call-method>
    <call-method name="addItem">
      <bean class="javax.swing.ImageIcon">
        <args><string>images/rating-4.gif</string></args>
      </bean>
    </call-method>
    <call-method name="addItem">
      <bean class="javax.swing.ImageIcon">
        <args><string>images/rating-5.gif</string></args>
      </bean>
    </call-method>
    <property name="selectedIndex">
      <string><xsl:value-of select="."/></string>
    </property>
    <listener name="action"/>
  </bean>
  </add>
</xsl:template>

</xsl:stylesheet>
