<?xml version="1.0"?>
<xsl:stylesheet
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns="http://www-sop.inria.fr/lemme/bo/1.0"
 version="1.0">

<!--===================================================================
    A XSLT script which displays a window with an editable text field
    holding the value of the element '<message>' of the source XML doc.
    The action event fired by the JTextField is associated with a
    script which performs two actions :
      1- it fires an event of type 'BeanEdit' to indicate that the
         property 'text' has changed
      2- it fires an event of type 'BeanEdit' to request the end of
         the process
    ===================================================================
 -->

<xsl:template match="message">
  <bean class="javax.swing.JFrame">
    <add>
      <bean class="javax.swing.JTextField" id="textf">
        <property name="text">
          <string><xsl:value-of select="."/></string>
        </property>
        <event-binding name="action">
          <script>
            <fire-event source="textf" name="text" type="CHANGE_PROPERTY"/>
            <fire-event type="END"/>
          </script>
        </event-binding>
      </bean>
    </add>
  </bean>
</xsl:template>

</xsl:stylesheet>
