<?xml version="1.0"?>
<xsl:stylesheet
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns="http://www-sop.inria.fr/lemme/bo/1.0"
 version="1.0">

<!--===================================================================
    A XSLT script which displays a window with an editable text field
    holding the value of the element '<message>' of the source XML doc.
    The events fired by the text component are not processed.

    But a button, with the value "Done", placed at the right, is
    used to fire both an event which indicates that the property 'text'
    of the text component has changed and an event which requests the
    end of the process
    ===================================================================
 -->

<xsl:template match="message">
  <bean class="javax.swing.JFrame">
    <add>
      <bean class="javax.swing.JTextField" id="textf">
        <property name="text">
          <string><xsl:value-of select="."/></string>
        </property>
      </bean>
      <string value="West"/>
    </add>
    <add>
      <bean class="javax.swing.JButton">
        <property name="text" value="Done"/>
        <event-binding name="action">
          <script>
            <fire-event source="textf" name="text" type="CHANGE_PROPERTY"/>
            <fire-event type="END"/>
          </script>
        </event-binding>
      </bean>
      <string value="East"/>
    </add>
  </bean>
</xsl:template>

</xsl:stylesheet>
