<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/TR/REC-html40" 
  result-ns="html">

  <xsl:output 
    method="html"
    indent="yes"
    encoding="ISO-8859-1"
    media-type="text/html"/>

<xsl:template match="/">
 <html>
  <head>
    <title>Restos DB</title>
    <link rel="stylesheet" type="text/css" href="restos.css"/>
   </head>
    <body>
      <div class="body">
	<a name="top">
	  <img src="logo.jpg" width="524" height="96" border="0"/>
	</a>
	<table width="99%">
        <tr>
          <td width="100%" bgcolor="#808080" cellpadding="0">
            <center>
              <a class="menu" href="restos-city.html">Trie par Villes</a> | 
              <a class="menu" href="restos-name.html">Trie par Noms</a> |
              <a class="menu" href="restos-type.html">Trie par Types</a> |
	      <a class="menu" href="addentry.html">Ajouter une critique</a>
            </center>
          </td>
        </tr>
        </table>
	<p/>
	<div class="legend">
	  <span class="firstletter">S</span>i vous etes amateur de bon
	  restos (qui ne l'est pas?) et si vous souhaitez connaitre
	  l'opinion d'autres personnes avant de vous decider, cette
	  page est faite pour vous! Et pensez a nous faire part de vos 
	  critiques...
	<p/>		
	  <u>Legende des critiques</u>: (Les etoiles ne refletent que
	la qualite de la cuisine, pas le rapport qualite/prix)
	<p/>
	  <span style="margin-left: 20pt">
	    <table border="0">
	    <tr><td><b>!!!</b></td><td>A eviter</td></tr>
	    <tr><td><b>*</b></td><td>Moyen</td></tr>
	    <tr><td><b>**</b></td><td>Bon</td></tr>
	    <tr><td><b>***</b></td><td>Tres bon</td></tr>
	    <tr><td><b>****</b></td><td>Excellent</td></tr>
	    <tr><td><b>*****</b></td><td>Exceptionnel</td></tr>
	    </table>
	  </span>
	</div>
	<center>
		<img src="critiques.jpg" height="54" width="398" 
		 alt="Les critiques..." border="0"/>
	</center>
	<xsl:apply-templates select="agenda"/>
	<p/>
	<hr noshade="noshade" width="30%" align="left"/>
	<span class="small">
	This page is generated from an <a href="restos.xml">xml file</a>
	using the following <a href="restos-main.xsl">XSL rules</a>.
	</span>
      </div>
   </body>
  </html>
</xsl:template>

<xsl:template match="entry">
  <div class="entry">
	<div style="float:right">
		<b><xsl:value-of select="type"/></b>
	</div>
	<div>
	<span style="font-weight: bold; font-size: 20pt; margin-right: 20pt">
	  <xsl:if test="url">
	  <xsl:element name="a">
	    <xsl:attribute name="href">
	       <xsl:value-of select="url"/>
	    </xsl:attribute>
	    <xsl:value-of select="name"/>
	   </xsl:element>
	  </xsl:if>
	  <xsl:if test="not(url)">
	  <xsl:value-of select="name"/>
	  </xsl:if>
	</span>
	<p/>
	<span style="font-weight: bold">
	  <xsl:value-of select="city"/>
	</span>
	<br/>
	<xsl:value-of select="address"/>
	<br/>
	Tel: <xsl:value-of select="tel"/>
	<p/>
	<b>Prix</b>: <xsl:value-of select="price"/>
	<p/>
	<div style="margin-left: 20pt">
	<table>
	  <tr>
	    <td class="color">Note</td>
	    <td class="color">Testeur</td>
	    <td class="color">Date</td>
	    <td class="color">Commentaires</td>
	  </tr>
	  <xsl:apply-templates select="rating">
		<xsl:sort select="@by"/>
	  </xsl:apply-templates>
	</table>
	</div>
	</div>
  </div>
</xsl:template>

<xsl:template match="rating">
  <tr>
    <td width="20pt">
      <span style="font-weight: bold; font-size:large">
	<xsl:value-of select="note"/>
      </span>
    </td>
    <td class="small" align="left">
      <span style="color: red">
        <xsl:element name="a">
          <xsl:attribute name="class">no-deco</xsl:attribute>
	  <xsl:attribute name="href">mailto:<xsl:value-of select="email"/>?subject=Restos-DB: <xsl:value-of select="ancestor::entry/name"/></xsl:attribute>
	  <xsl:value-of select="@by"/>
        </xsl:element>
      </span>
    </td>
    <td>
      <xsl:value-of select="date"/>
    </td>
    <td>
      <xsl:value-of select="comments"/>
    </td>
  </tr>
</xsl:template>

<xsl:template match="links">
	<xsl:for-each select="link">
	  <xsl:element name="a">
	    <xsl:attribute name="class">menu</xsl:attribute>
	    <xsl:attribute name="href"><xsl:value-of select="@url"/></xsl:attribute>
	    <xsl:value-of select="."/>
	   </xsl:element>
	|
	</xsl:for-each>
	<xsl:text> </xsl:text><a class="menu" href="#top">Top</a>
</xsl:template>

</xsl:stylesheet>
