<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www-sop.inria.fr/lemme/bo/1.0"
                version="1.0">
 <xsl:template match="/">
  <bean class="fr.inria.ketuk.widgets.VBox">
    <bean class="fr.inria.ketuk.widgets.html.Label" action="add">
      <args><string value="Order Summary"/></args>
      <property name="style" value="h1"/>
    </bean>
    <xsl:apply-templates select="sales/order"/>
  </bean>
</xsl:template>
 <xsl:template match="order">
  <xsl:apply-templates select="cust"/>
  <xsl:apply-templates select="prods"/>
</xsl:template>
 <xsl:template match="cust">
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>client:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="name"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>email:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="email"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>phone:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text"> 
         <string><xsl:value-of select="phone"/></string>
      </property>
    </bean>
  </bean>
  <bean class="fr.inria.ketuk.widgets.html.Label" action="add">
    <args><string>Billing Information</string></args>
    <property name="style" value="h3"/>
  </bean>
  <xsl:apply-templates select="billing"/>
  <xsl:if test="shipping">
    <bean class="fr.inria.ketuk.widgets.html.Label" action="add">
      <args><string>Shipping Information</string></args>
      <property name="style" value="h3"/>
    </bean>
    <xsl:apply-templates select="shipping"/>
  </xsl:if>
  <bean class="fr.inria.ketuk.widgets.html.Label" action="add">
    <args><string>Credit Card Information</string></args>
    <property name="style" value="h3"/>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>card type:</string></args>
    </bean>
    <bean class="javax.swing.JComboBox" action="add">
      <args>
        <array>
          <string value="Visa"/>
          <string value="Mastercard"/>
          <string value="American Express"/>
        </array>
      </args>
      <property name="selectedItem">
        <string><xsl:value-of select="creditcard/@type"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>card number:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="creditcard/@number"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>expiration date:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="creditcard/@date"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
</xsl:template>
 <xsl:template match="billing|shipping">
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>street:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="street"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>city:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="city"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>state:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="state"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>zip:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="zip"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
  <bean class="javax.swing.JPanel" action="add">
    <bean class="javax.swing.JLabel" action="add">
      <args><string>country:</string></args>
    </bean>
    <bean class="javax.swing.JTextField" action="add">
      <property name="text">
        <string><xsl:value-of select="country"/></string>
      </property>
      <listener name="action"/>
    </bean>
  </bean>
</xsl:template>
 <xsl:template match="prods">
  <bean class="fr.inria.ketuk.widgets.html.Label" action="add">
    <args><string>Order Details</string></args>
    <property name="style" value="h3"/>
  </bean>
  <bean class="fr.inria.ketuk.widgets.html.Table" action="add">
    <property name="borderw" value="1"/>
    <bean class="fr.inria.ketuk.widgets.html.TR" action="add">
      <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
        <bean class="javax.swing.JLabel" action="add">
          <args><string>Ink name</string></args>
        </bean>
      </bean>
      <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
        <bean class="javax.swing.JLabel" action="add">
          <args><string>Color</string></args>
        </bean>
      </bean>
      <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
        <bean class="javax.swing.JLabel" action="add">
          <args><string>Quantity</string></args>
        </bean>
      </bean>
      <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
        <bean class="javax.swing.JLabel" action="add">
          <args><string>Price</string></args>
        </bean>
      </bean>
      <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
        <bean class="javax.swing.JLabel" action="add">
          <args><string>Total</string></args>
        </bean>
      </bean>
    </bean>
    <xsl:apply-templates select="prod"/>
  </bean>
</xsl:template>
 <xsl:template match="prod">
  <xsl:variable name="product" select="/sales/products/product[@id=current()/@idref]"/>
  <bean class="fr.inria.ketuk.widgets.html.TR" action="add">
    <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
      <bean class="fr.inria.ketuk.demos.sales.SalesComboBox" action="add">
        <args>
          <array>
            <xsl:for-each select="/sales/products/product">
              <string><xsl:value-of select="@id"/></string>
            </xsl:for-each>
          </array>
          <array>
            <xsl:for-each select="/sales/products/product">
              <string><xsl:value-of select="@name"/></string>
            </xsl:for-each>
          </array>
        </args>
        <property name="selectedId">
          <string><xsl:value-of select="@idref"/></string>
        </property>
        <listener name="action"/>
      </bean>
    </bean>
    <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
      <bean class="javax.swing.JComboBox" action="add">
        <args>
          <array>
            <string value="blue"/>
            <string value="black"/>
          </array>
        </args>
        <property name="selectedItem">
          <string><xsl:value-of select="@color"/></string>
        </property>
        <listener name="action"/>
      </bean>
    </bean>
    <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
      <bean class="javax.swing.JTextField" action="add">
        <property name="text">
        <string><xsl:value-of select="@qty"/></string>
      </property>
        <listener name="action"/>
      </bean>
    </bean>
    <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
      <bean class="javax.swing.JLabel" action="add">
        <property name="text">
          <string><xsl:value-of select="$product/@price"/></string>
        </property>
      </bean>
    </bean>
    <bean class="fr.inria.ketuk.widgets.html.TD" action="add">
      <bean class="javax.swing.JLabel" action="add">
        <property name="text">
          <string><xsl:value-of select="@qty * $product/@price"/></string>
        </property>
      </bean>
    </bean>
</bean>
</xsl:template>
</xsl:stylesheet>