<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<xsl:template match="/">           
  <html>
    <head>
      <title>Order summary</title>
    </head>
    <body bgcolor="white">
      <h1>Order Summary</h1>
      <xsl:apply-templates select="sales/order"/>
    </body>
  </html>
</xsl:template>

<xsl:template match="order">
  <xsl:apply-templates select="cust"/>
  <xsl:apply-templates select="prods"/>
</xsl:template>

<xsl:template match="cust">
  <p>
    client: <xsl:value-of select="name"/>
  </p>
  <p>
    email: <xsl:value-of select="email"/>
  </p>
  <p>
    phone: <xsl:value-of select="phone"/>
  </p>
  <h3>Billing Information</h3>
  <xsl:apply-templates select="billing"/>
  <xsl:if test="shipping">
    <h3>Shipping information</h3>
    <xsl:apply-templates select="shipping"/>
  </xsl:if>
  <h3>Credit Card Information</h3>
  <p>
    card type: <xsl:value-of select="creditcard/@type"/>
  </p>
  <p>
    card number: <xsl:value-of select="creditcard/@number"/>
  </p>
  <p>
    expiration date: <xsl:value-of select="creditcard/@date"/>
  </p>
</xsl:template>

<xsl:template match="billing|shipping">
  <p>
    street: <xsl:value-of select="street"/>
  </p>
  <p>
    city: <xsl:value-of select="city"/>
  </p>
  <p>
    state: <xsl:value-of select="state"/>
  </p>
  <p>
    zip: <xsl:value-of select="zip"/>
  </p>
  <p>
    country: <xsl:value-of select="country"/>
  </p>
</xsl:template>

<xsl:template match="prods">
  <h3>Order details</h3>
  <table border="1">
    <tr>
      <td>Ink name</td>
      <td>color</td>
      <td>quantity</td>
      <td>price</td>
      <td>total</td>
    </tr>
    <xsl:apply-templates select="prod"/>
  </table>
</xsl:template>

<xsl:template match="prod">
  <xsl:variable name="product" select="/sales/products/product[@id=current()/@idref]"/>
  <tr>
    <td>
      <xsl:value-of select="$product/@name"/>
    </td>
    <td>
      <xsl:value-of select="@color"/>
    </td>
    <td>
      <xsl:value-of select="@qty"/>
    </td>
    <td>
      <xsl:value-of select="$product/@price"/>
    </td>
    <td>
      <xsl:value-of select="@qty * $product/@price"/>
    </td>
  </tr>
</xsl:template>
</xsl:stylesheet>
