<?xml version="1.0"?>
<xsl:stylesheet
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns="http://www-sop.inria.fr/lemme/bo/1.0"
 version="1.0">

<xsl:template match="stock_quotes">
  <bean class="fr.inria.ketuk.demos.stockQuotes.StockQuotesParser" id="stockQ">
    <xsl:apply-templates select="stock_quote"/>

    <bean class="com.ibm.webaccessor.EasyNetworking" id="webaccess">
      <call-method name="setInputURL">
        <string>
          <xsl:text>http://www.xmltoday.com/examples/stockquote/getxmlquote.vep?s=</xsl:text>
          <xsl:for-each select="stock_quote/symbol">
            <xsl:value-of select="."/>
            <xsl:if test="not(position()=last())"><xsl:text>+</xsl:text></xsl:if>
          </xsl:for-each>
        </string>
      </call-method>

      <event-binding name="triggerNextAction">
      <script>
        <property name="quotes" target="stockQ">
          <call-method name="getResultDataAsString" target="webaccess"/>
        </property>
        <fire-event source="stockQ" type="CHANGE_PROPERTY"/>
        <fire-event type="END"/>
      </script>
      </event-binding>
    </bean>

    <call-method name="triggerAction" target="webaccess"/>

  </bean>
</xsl:template>

<xsl:template match="stock_quote">
  <property name="symbol" index="{position()-1}">
    <string><xsl:value-of select="symbol"/></string>
  </property>
  <property name="date" index="{position()-1}">
    <string><xsl:value-of select="date"/></string>
  </property>
  <property name="time" index="{position()-1}">
    <string><xsl:value-of select="time"/></string>
  </property>
  <property name="ask" index="{position()-1}">
    <string><xsl:value-of select="price[@type='ask']/@value"/></string>
  </property>
  <property name="open" index="{position()-1}">
    <string><xsl:value-of select="price[@type='open']/@value"/></string>
  </property>
  <property name="dayhigh" index="{position()-1}">
    <string><xsl:value-of select="price[@type='dayhigh']/@value"/></string>
  </property>
  <property name="daylow" index="{position()-1}">
    <string><xsl:value-of select="price[@type='daylow']/@value"/></string>
  </property>
  <property name="change" index="{position()-1}">
    <string><xsl:value-of select="change"/></string>
  </property>
  <property name="volume" index="{position()-1}">
    <string><xsl:value-of select="volume"/></string>
  </property>
</xsl:template>

</xsl:stylesheet>
